/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gui;

import classificador.Resultado;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.ScrollPane;
import java.util.LinkedList;
import javax.swing.JScrollPane;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.labels.ItemLabelAnchor;
import org.jfree.chart.labels.ItemLabelPosition;
import org.jfree.chart.labels.StandardCategoryItemLabelGenerator;
import org.jfree.chart.plot.CategoryPlot;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.renderer.category.BarRenderer;
import org.jfree.data.category.CategoryDataset;
import org.jfree.data.category.DefaultCategoryDataset;
import org.jfree.ui.TextAnchor;
/**
 *
 * @author LABGRAPH
 */
public class GraficoResultado {
    private String titulo;
    private CategoryDataset conjuntoDeDados;
    private JFreeChart grafico;
    private LinkedList<Resultado> listaResultados;
    private ChartPanel painelGrafico;
    
    /** Creates new form QuadroGraficoResultado */
    GraficoResultado(String tituloTemp, LinkedList<Resultado> listaResultados) {
        this.titulo = tituloTemp;
        this.listaResultados = listaResultados;
    }

    
    private void gerarGraficoTaxaPorContexto(){
        DefaultCategoryDataset dados = new DefaultCategoryDataset();
        double []resultadosPorContexto = new double[listaResultados.size()];
        
        for(int i = 0; i < resultadosPorContexto.length; i++){
            double somatorio = 0;
            for(Integer taxaCompositor : listaResultados.get(i).getAcertosPorCompositor()){
                somatorio = somatorio + taxaCompositor;
            }
            
            resultadosPorContexto[i] = somatorio/listaResultados.get(i).getQuantidadeDeCompositores();
        }
        
        
        for (int i = 0; i < resultadosPorContexto.length; i++ ) {
            dados.addValue( resultadosPorContexto[i]*100/listaResultados.get(i).getQuantidadeDeArquivosPorCompositor()
                    , "taxa", "Contexto "+listaResultados.get(i).getContexto());
        }
        
        conjuntoDeDados = dados;
        grafico = criarGrafico(titulo, "Contexto", conjuntoDeDados);
    }
    
    private void gerarGraficoTaxaPorContextoPorCompositor(){
        DefaultCategoryDataset dados = new DefaultCategoryDataset();
        
        for (int i = 0; i < listaResultados.size(); i++ ) {
            for(int j = 0; j < listaResultados.get(i).getQuantidadeDeCompositores(); j++ ){
                dados.addValue( listaResultados.get(i).getAcertosPorCompositor()[j]*100/listaResultados.get(i).getQuantidadeDeArquivosPorCompositor(),
                                listaResultados.get(i).getNomeCompositores()[j],
                                Integer.toString(listaResultados.get(i).getContexto()));
            }
            
        }
        conjuntoDeDados = dados;
        grafico = criarGrafico(titulo, "Contexto", conjuntoDeDados);
    }
    
    private void gerarGraficoTaxaPorCompositorPorContexto(){
        DefaultCategoryDataset dados = new DefaultCategoryDataset();
        
        for (int i = 0; i < listaResultados.size(); i++ ) {
            for(int j = 0; j < listaResultados.get(i).getQuantidadeDeCompositores(); j++ ){
                dados.addValue( listaResultados.get(i).getAcertosPorCompositor()[j]*100/listaResultados.get(i).getQuantidadeDeArquivosPorCompositor(),
                                Integer.toString(listaResultados.get(i).getContexto()),
                                listaResultados.get(i).getNomeCompositores()[j]);
            }
            
        }
        conjuntoDeDados = dados;
        grafico = criarGrafico(titulo, "Contexto", conjuntoDeDados);
    }
    
    private JFreeChart criarGrafico(String titulo, String categoria, final CategoryDataset conjuntoDeDados){
        JFreeChart graficoTemp = ChartFactory.createBarChart(
                titulo,
                categoria,
                "Taxa",
                conjuntoDeDados,
                PlotOrientation.VERTICAL,
                true, true, false);
        
        graficoTemp.setBackgroundPaint(Color.WHITE);
        
        
        // Layout
        CategoryPlot plot = graficoTemp.getCategoryPlot();
        BarRenderer renderer = (BarRenderer) plot.getRenderer();              
        renderer.setBaseSeriesVisible(true);    
        renderer.setBaseItemLabelGenerator(new StandardCategoryItemLabelGenerator());                 
        renderer.setBaseItemLabelsVisible(true); 
        
        ItemLabelPosition p = new ItemLabelPosition(ItemLabelAnchor.INSIDE12,  
                TextAnchor.CENTER_RIGHT, TextAnchor.CENTER_RIGHT,  
                -Math.PI / 2.0);  
        renderer.setBasePositiveItemLabelPosition(p);  
  
        ItemLabelPosition p2 = new ItemLabelPosition(ItemLabelAnchor.OUTSIDE12,  
                TextAnchor.CENTER_LEFT, TextAnchor.CENTER_LEFT, -Math.PI / 2.0);  
        renderer.setPositiveItemLabelPositionFallback(p2); 
        
        graficoTemp.getCategoryPlot().setRenderer(renderer);
        // fim Layout
        
        return graficoTemp;
    }

    /**
     * @return the titulo
     */
    public String getTitulo() {
        return titulo;
    }

    /**
     * Retorna o painelGrafico com dados por Contexto
     * @return the painelGrafico
     */
    public ChartPanel getPainelGraficoTaxaPorContexto() {
        gerarGraficoTaxaPorContexto();
        painelGrafico = new ChartPanel(grafico);
        painelGrafico.setPreferredSize(new Dimension(300, 200));
        return painelGrafico;
    }
    
    /**
     * Retorna o painelGrafico com dados por Contexto por Compositor
     * @return the painelGrafico
     */
    public ChartPanel getPainelGraficoTaxaPorContextoPorCompositor() {
        gerarGraficoTaxaPorContextoPorCompositor();
        painelGrafico = new ChartPanel(grafico);
        painelGrafico.setPreferredSize(new Dimension(300, 200));  
        return painelGrafico;
    }
    
    /**
     * Retorna o painelGrafico com dados por Compositor por Contexto
     * @return the painelGrafico
     */
    public ChartPanel getPainelGraficoTaxaPorCompositorPorContexto() {
        gerarGraficoTaxaPorCompositorPorContexto();
        painelGrafico = new ChartPanel(grafico);
        painelGrafico.setPreferredSize(new Dimension(300, 200));  
        return painelGrafico;
    }
}
